package ButtonExample;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

/**
 * Class demonstrated functionality of a Button.
 * It displays Magic text in the text field
 * 
 * @author mhotan
 *
 */
public class MagicButton {
	
	private JButton button;
	private JButton button2;
	private JFrame frame;
	private JTextField tField;
	
	// Constructs the GUI and displays it on the screen.
	public MagicButton() {
		// create some components (buttons)
		// Create first button
		button = new JButton("Click me to see what happens");
		button.setBackground(Color.RED);		
//		button.setOpaque(true); // This is needed for MAC OS to show color differences
//		button.setBorderPainted(false); // This is needed for MAC OS to show color differences
		
		//Create Second Button
		button2 = new JButton("No! Click me to see what happens");
		button2.setBackground(Color.YELLOW);
//		button2.setOpaque(true); // This is needed for MAC OS to show color differences
//		button2.setBorderPainted(false); // This is needed for MAC OS to show color differences
			
		//Dont worry about this just yet
		doListenerStuff();
		
		// Create Text Display
		tField = new JTextField();
		tField.setFont(new Font("Comic Sans MS", Font.BOLD, 16));
		tField.setHorizontalAlignment(JTextField.CENTER);

		// create overall window (frame) and put buttons in it
		frame = new JFrame("331 is great");
		frame.setLocation(300, 100);
		frame.setSize(800, 300);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		// layout manager decides how to position/size the components in the frame
		frame.setLayout(new BorderLayout());
		frame.add(button, BorderLayout.NORTH);
		frame.add(button2, BorderLayout.SOUTH);
		frame.add(tField, BorderLayout.CENTER);

		//Have to Set to be Visible
		frame.setVisible(true);
	}
	
	/*
	 * Listener intialization and 
	 */
	private void doListenerStuff() {
		// attach event listener to handle mouse clicks
		MyAwesomeListener listener = new MyAwesomeListener();
		
		//Lets ensure we register the listener
		button.addActionListener(listener);
		button2.addActionListener(listener);
	}

	// This class handles "action events", aka mouse clicks, in buttons.
	public class MyAwesomeListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == button) {
				//Swap Colors
				if (button2.getBackground() == Color.YELLOW)
					button2.setBackground(Color.BLUE);
				else
					button2.setBackground(Color.YELLOW);
				tField.setText(MagicSayings.getNext());
			} else {// event source is button2
				//Swap Colors
				if (button.getBackground() == Color.RED)
					button.setBackground(Color.BLUE);
				else
					button.setBackground(Color.RED);
				tField.setText(MagicSayings.getPrevious());
			}
		}
	}
}
