package WindowExample;

//Look we have to incorporate awt and swing
// No big deal when you don't abuse
import java.awt.Color;
import java.awt.Font;

import javax.swing.JFrame;
import javax.swing.JTextField;

/**
 * This class is a GUI example of implementing a window
 * with swing.
 * 
 * @author mhotan
 *
 */
public class SimpleWindow {
	//Notice that this is not an ADT therefore has no RI or AF
	
	//Lets declare some fields for our GUI
	//Declare a window Window
	private JFrame frame;
	
	//Declare some Components
	private JTextField tfield;
	
	/**
	 * Constructor for this object 
	 * It creates and shows a simple window 
	 * this window displays the text inputed as argument
	 * 
	 * @param text , Text to be printed inside this window
	 * @modifies this
	 * @effects initializes this and displays this to the screen
	 */
	public SimpleWindow(String text){
		
		/*Initialize the Text Field*/
		
		//Why is tfield declared as a field?
		//And not as a local object within the constructor
		tfield = new JTextField(text);
	
		// Text field size methods
		//tfield.setPreferredSize(new Dimension(400, 100));
		tfield.setSize(100, 400);
		
		/*Set the parameters of the Text Field*/
		
		tfield.setBackground(Color.CYAN /* Ugly Ugly */); //Set background color 
		tfield.setForeground(Color.RED); //Set Font Color
		tfield.setSelectedTextColor(Color.YELLOW); //Set color of font when selected
		tfield.setFont(new Font("Comic Sans MS", Font.BOLD, 20)); // Eww Comic Sans ;-P
		//Oh my, this is going to look bad
		
		//At least ill make the text centered
		tfield.setHorizontalAlignment(JTextField.CENTER);
		
		/*initialize the JFrame*/
		
		//Lets initialize the frame/window
		frame = new JFrame("Title: " + text);	
		//Ensure that if the User exits the window, the application stops
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		/*set Location of the Frame*/
		
//		frame.setLocationRelativeTo(null); //Wait does this mean?
//		frame.setLocation(100, 100);
		//2
		
		/*Set the size of the Frame*/
		
//		frame.setExtendedState(JFrame.MAXIMIZED_BOTH); //What does this do? 
//		frame.setSize(500, 300);
//		frame.pack(); //pack what? //Only frames can pack	
		//1
	}
}


